<?php



/**
 * implementiert die CRUD Operationen für SIP Konten
 * @author Miguel Palmer <mp@beronet.com>
 */

class Sip {

	private		$m_attr,
			$q_attr,
			$start_attr,
			$order_attr,
			$sort_attr;

	private		$isRequestRejected = 0,
			$reasonRejected = array();

	/**
	 * Constructor
	 */
	function __construct($m, $get = array(), $post = array(), $session = array()) {
		// set main index page
		$this->m_attr = $m;

		// check GET variable
                $this->q_attr 	  = isset($get['q']) 	 ? Helper::sanitizeGet($get['q']	 , 'q'	  ) : 0;
                $this->start_attr = isset($get['start']) ? Helper::sanitizeGet($get['start']	 , 'start') : 0;
                $this->order_attr = isset($get['order']) ? Helper::sanitizeGet($get['order']	 , 'order') : 0;
                $this->sort_attr  = isset($get['sort'])  ? Helper::sanitizeGet($get['sort'] 	 , 'sort' ) : 0;

		// get error from modal or submit execution
		if (isset($get['error'])) {
			$this->isRequestRejected = 1;
			$this->reasonRejected = array('request' => $get['request'], 'checkor' => $get['checkor'], 'key' => $get['key']);
			unset($get['error'], $get['request'], $get['checkor'], $get['key']);
		}
	}

	/**
	 * Generiert den Inhalt von der HTML-Seite
	 * @return string HTML Seite
	 */
	function display() {

		include "./includes/functions.php";

		// args
		$m = $this->m_attr;
		$q = $this->q_attr;
		$start = $this->start_attr;
		$order = $this->order_attr;
		$sort = $this->sort_attr;

		$ba = new beroAri();

		$span = 15;
		$query = $ba->select('SELECT * FROM sip');
		$record_count = sqlite_num_rows($query);
		$test=$record_count/$span;
		$test=(int)$test;
		if ($record_count==0){
			$next_add=0;
		}else{
			$next_add=($test*$span);
		}

		$start = $start == '' ? 0 : $start;
                
        	$name = "SIP_TITLE_DIS";
		include('./includes/header.php');

		if ($this->isRequestRejected) {
			$ret .= Helper::displayErrorMessage($this->reasonRejected['request'], $this->reasonRejected['checkor'], $this->reasonRejected['key']);
		}

		$sip_table = $this->dynamic_table();

		// build page content
		$ret .= "<script>
				function del(table,option,name){
					conf = confirm('".SIP_DELETE_MESS1_DIS." '+name+'? ".SIP_DELETE_MESS2_DIS."');
					if (conf==false)
						return false;
					else
						window.location='./misc/delete.php?m=".$this->m_attr."&id='+option+'&table='+table+'&name='+name;
				}
			</script>
			<div class='modal fade bs-example-modal-lg' id='sip-popup' tabindex='-1' role='dialog' aria-labelledby='myModalLabel' aria-hidden='true'>
			  <div class='modal-dialog modal-lg'>
			    <div class='modal-content'>
			      <div class='modal-header'>
				<button type='button' class='close' data-dismiss='modal' aria-label='Close'><span aria-hidden='true'>&times;</span></button>
				<h4 class='modal-title' id='myModalLabel'>" . SIP_TITLE_DIS . "</h4>
			      </div>
			      <div class='modal-body'>
			      </div>
			    </div>
			  </div>
			</div>
			 <br>
			 <div id='container table-responsive'>
			 " . $sip_table . "
			 </div>
			 <div class='text-center'>
				<a href='modules/Sip/sip_popup.php?start=$next_add&profile=undefined&type=manual' role='button' data-remote='false' data-toggle='modal' data-target='#sip-popup' class='btn btn-default'>
				" . BUTTON_ADD . "
				</a>
			 </div>";


//				<a href='modules/Sip/sip_popup.php?start=" . $next_add . "' role='button' data-remote='false' data-toggle='modal' data-target='#sip-popup' class='btn btn-default'>   /* Old code: used to add different predefined profiles

		//Erzeugung der Navigationsleiste.
		$functions = new functions();
		$query = $ba->select('SELECT * FROM sip');
		$record_count = sqlite_num_rows($query);
		$url_opts = array ();
		$url_opts['sort'] = $sort;
		$url_opts['order'] = $order;
		$ret .= "<div class='text-center'>".
			$functions->displayNavigationBlock($m, $q, $url_opts, $start, $span, $record_count).
			"</div>";

		return $ret;
	}

	/**
	 * Generiert die HTML Tabelle mit den SIP Einträgen
	 * @return string HTML Tabelle
	 */
	function dynamic_table() {
		$ba = new beroAri();
		require_once("./includes/lang.php");
		$start = $this->start_attr;

		//Das Header der Tabelle sind die Spaltennamen von dialplan
		$columns = $ba->column_type('sip');
		$i = 0;
                //$columnsToShow=array("name","user","register","profile"); /* Old code: used to display different predefined SIP-profile */
                //$colName=array("name"=>SIP_NAME_DIS,"user"=>SIP_USER_DIS,"register"=>SIP_REGISTER_DIS,"profile"=>SIP_PROFILE_DIS); /* Old code: used to display different predefined SIP-profile */
                $columnsToShow=array("name","user","register");
                $colName=array("name"=>SIP_NAME_DIS,"user"=>SIP_USER_DIS,"register"=>SIP_REGISTER_DIS);
		foreach ($columns as $column => $type) {
			if (in_array($column,$columnsToShow)) $cols .= "<th>" . $colName[$column] . "</th>";
		}

		/*Die Einträge werden von der Tabelle sip gelesen, formatiert und in einer
		  Tabelle geschrieben, zusätzlich werden 2 Knöpfe eingebaut: modify und delete*/
		$page = (($start / 15) + 1);
		if (!$start)
			$start = 0;
		$id = 0;
		for ($j = 1; $j <= $page; $j++) {
			$query = $ba->select('SELECT * FROM sip ORDER BY id asc limit 15 offset ' . sqlite_escape_string($start));
			$rows = '<tbody>';
			while ($entry = $ba->fetch_array($query)) {
				$rows .= "<tr>";
				for ($i = 0; $i < (count($columnsToShow)); $i++) {
					$col_name = $columnsToShow[$i];
					$rows .= "<td>" . $entry[$col_name]  . "</td>";

				}
				$id = $entry['id'];
				$rows .= "<td class='buttons'>
					
				 <a href='modules/Sip/sip_popup.php?id=" . $entry['id'] . "' data-remote='false' data-toggle='modal' data-target='#sip-popup' class='popup_download'>
					<img src='./includes/images/modify.png' onmouseover=\"Tip('" . MOD_SIP_MODIFY . "')\" onmouseout='UnTip()'>
				</a>&nbsp;
				<a class='popup_download' onclick=\"del('sip','".$id."','".$entry['name']."');\">
            	    <img src='./includes/images/delete.png' onmouseover=\"Tip('" .
					MOD_SIP_DELETE . "')\" onmouseout='UnTip()'>
				</a>
				</td></tr>";
			}
			$rows .= '</tbody>';
		}

		$table = "<table class='table table-striped table-bordered'><tr><thead>" . $cols . "<th></th></tr></thead>" . $rows . "</table>"
			. "<script>"
			. "$('#sip-popup').on('show.bs.modal', function(e) {"
			. "var link = $(e.relatedTarget);"
			. "$('.modal-body').load(link.attr('href'));"
			. "});"
			. "$('#sip-popup').on('hidden.bs.modal', function (e) { "
			. "$('.modal-body').empty(); "
			. "});" .
			"</script>";
		//Rückgabe: Erzeugte Tabelle mit den Einträgen der Tabelle sip der Datenbank
		return $table;
	}

}
?>
